//
//	Structure headder
//
#include  "MOTTYPES.h"
#include	"hidef.h"

//
//	String macros
//
#define	StrCpy(x,y)	strcpy((INT8*)(x), (INT8*)(y))
#define	StrCat(x,y)	strcat((INT8*)(x), (INT8*)(y))
#define	StrCmp(x,y)	strcmp((INT8*)(x), (INT8*)(y))
#define	StrLen(x)		strlen((INT8*)(x))

//
//	High/Low macros
//
#define	LOWBYTE(X)	((X) & 255)
#define	HIGHBYTE(X)	((X) >> 8)

//
//
//
#define	countof(x)	(sizeof(x)/(sizeof((x)[0])))
#define TRUE  1
#define FALSE 0
#define	LOW_POWER_WHILE		asm("wait")
#define	EnterCritical	{TPM1SC_TOIE = 0;}
#define	ExitCritical	{TPM1SC_TOF = 0;TPM1SC_TOIE = 1;}

//
//	Definition for hook table
//
typedef void (*near HookFunc)(void);
typedef void(*CallbackFunc8)(UINT8);
typedef void(*CallbackFunc16)(UINT16);
typedef void(*CallbackFuncV)(void);

//
//	Jump table structure  (06, HH, LL)
//
typedef struct	
{								// JMP adrs table from 0x3f00
	UINT8	opcode;	// Will be 0x06 (JMP instruction)
	HookFunc	adrs;// Will be address (2 byte)
}	tJumpTable;

//
//	Registry entry structure
//
typedef struct
{
	INT8	*name;	// Var name
	void	*adrs;	// Var pointer
	UINT8	len;		// String or Integer length or bit pos
	UINT8	attr;		// 1 0-7:bit 9:byte 10:word 12:dword 80-FF:string (&7f is length)	
} VarEntry;

//
//	Modem struct
//
typedef struct 
{
	UINT8 Length;
	UINT8 *data;
	UINT8 status;

} RxPacket_t;

typedef struct
{
	UINT8 Length;
	UINT8 *data;

} TxPacket_t;

//
//	Packet data struct
//
typedef	struct 
{
	UINT16	DeviceID;
	UINT8	AckSeq;
	UINT8	SeqNum;
	UINT8	Size;
	UINT8	WaitTime;

	UINT8	data[119];
}	PacketBuffer_t;


