#include	"MC9S08GT60.h"

// Silent settings. 
	#define MODEM_CE					PTED_PTED2				
	#define MODEM_CE_PORT			PTEDD_PTEDD2				
	#define MODEM_ATTN				PTDD_PTDD0
	#define MODEM_ATTN_PORT		PTDDD_PTDDD0
	#define MODEM_RTXEN				PTDD_PTDD1
	#define MODEM_RTXEN_PORT	PTDDD_PTDDD1
	#define MODEM_RESET				PTDD_PTDD3
	#define MODEM_RESET_PORT	PTDDD_PTDDD3
	#define MODEM_RESET_PULLUP 	PTDPE_PTDPE3
	#define MODEM_IRQ_SOURCE	IRQSC
	#define MODEM_IRQ_IE_BIT	IRQSC_IRQIE


	#define LED1_OFF		PTAD_PTAD0 = 1					
	#define LED1_ON		  PTAD_PTAD0 = 0					
	#define LED1_XOR	  PTAD_PTAD0 ^= 1					
	#define LED1_OUT		PTADD_PTADD0 = 1	
	#define LED2_OFF		PTAD_PTAD1 = 1					
	#define LED2_ON	  	PTAD_PTAD1 = 0					
	#define LED2_XOR	  PTAD_PTAD1 ^= 1					
	#define LED2_OUT		PTADD_PTADD1 = 1				
	#define LED3_OFF		PTAD_PTAD2 = 1					
	#define LED3_ON	  	PTAD_PTAD2 = 0					
	#define LED3_XOR	  PTAD_PTAD2 ^= 1					
	#define LED3_OUT		PTADD_PTADD2 = 1				
	#define LED4_OFF		PTAD_PTAD3 = 1					
	#define LED4_ON	  	PTAD_PTAD3 = 0					
	#define LED4_XOR	  PTAD_PTAD3 ^= 1					
	#define LED4_OUT		PTADD_PTADD3 = 1				

	#define PB1					PTBD_PTBD4						
	#define PB1_PUE			PTBPE_PTBPE4 = 1					
	#define PB2					PTBD_PTBD5 					
	#define PB2_PUE			PTBPE_PTBPE5 = 1 				
	#define PB3					PTBD_PTBD6 					
	#define PB3_PUE			PTBPE_PTBPE6 = 1 				
	#define PB4					PTBD_PTBD7 					
	#define PB4_PUE			PTBPE_PTBPE7 = 1 				

	#define PUSH_BUTTON1 PTBD_PTBD4
	#define PUSH_BUTTON2 PTBD_PTBD5
	#define PUSH_BUTTON3 PTBD_PTBD6
	#define PUSH_BUTTON4 PTBD_PTBD7

	#define	RL1_OFF			PTAD_PTAD4 = 0
	#define	RL1_OUT			PTADD_PTADD4 = 1
	#define	RL2_OFF			PTDD_PTDD4 = 0
	#define	RL2_OUT			PTDDD_PTDDD4 = 1

#define	DEB1ON  PTCD_PTCD0 = 1
#define	DEB1OFF	PTCD_PTCD0 = 0
#define	DEB1XOR	PTCD_PTCD0 ^= 1
#define	DEB2ON  PTCD_PTCD1 = 1
#define	DEB2OFF PTCD_PTCD1 = 0
#define	DEB2XOR PTCD_PTCD1 ^= 1

#define	RTS_PORT	PTDDD_PTDDD2	// RTS port direction for output
#define	RTS_DATA	PTDD_PTDD2	// RTS port direction for output
#define	CTS_PORT	PTCDD_PTCDD3	// RTS port direction for output
#define	CTS_DATA	PTCD_PTCD3	// RTS port direction for output

#define	RTS_ON		0		// Invert
#define	RTS_OFF		1		// Invert
#define	CTS_ON		0		// Invert
#define	CTS_OFF		1		// Invert
	
#define	LED_OFF	1
#define	LED_ON	0
#define	PRESSED	0

#ifdef	CAM
	#define	SCIBDH   SCI2BDH
	#define	SCIBDL   SCI2BDL
	#define	SCIC1    SCI2C1 
	#define	SCIC2    SCI2C2 
	#define	SCIC2_TIE	SCI2C2_TIE
	#define	SCIC2_RIE	SCI2C2_RIE
	#define	SCIS1    SCI2S1 
	#define	SCIS2    SCI2S2 
	#define	SCIC3    SCI2C3 
	#define	SCID     SCI2D

	#define	SCIS1_TDRE SCI2S1_TDRE
	#define	SCIS1_TC	 SCI2S1_TC
#else
	#define	SCIBDH   SCI1BDH
	#define	SCIBDL   SCI1BDL
	#define	SCIC1    SCI1C1 
	#define	SCIC2    SCI1C2 
	#define	SCIC2_TIE	SCI1C2_TIE
	#define	SCIC2_RIE	SCI1C2_RIE
	#define	SCIS1    SCI1S1 
	#define	SCIS2    SCI1S2 
	#define	SCIC3    SCI1C3 
	#define	SCID     SCI1D

	#define	SCIS1_TDRE SCI1S1_TDRE
	#define	SCIS1_TC	 SCI1S1_TC
#endif

#define	MODEM_CLKO_FREQ	0x01 // Sets the modem CLKO frequency 
#define	LOW_POWER_WHILE	asm("wait")
